#!/usr/bin/python

# (C) 2008 Sean Brennan <sean@zettix.com>

import sys
import os
import re
import cgi
import math
import time
#import Image
#mport ImageDraw
import glob
import os
import os.path


form = cgi.FieldStorage() # instantiate only once!

upload_image = form.getfirst('Image', '')

class ParseError(Exception):
  pass

def pdict(f):
  if type(f) == type({}):
    for x in f:
      print "%s : %s <br>" % (x, f[x])
  else:
    print "%s - [%s] <br>" % (f, str(type(f)))

class BlenderWeb(object):
  def __init__(self):
    self.error = ''
    self.image = None
    self.filename = ''

  def RunBlender(self):
    # for testing:
    #os.system('./super-duper.py -re %f -im %f -radius %f ' %
    item = form['Image']
    if item.file:
      data = item.file.read()
    else:
      print "NOOOOOOOOOOOOOOO   File found <br>"
      data = "No file"
    self.filename = item.filename
    for badchar in (' ', '\\', '/', '\'', '"', '&', '|'):
      self.filename = self.filename.replace(badchar, '_')
    outfile = open('/var/www/html/3d-filter/%s' % self.filename, 'w')
    outfile.write(data)
    outfile.close()
    os.system('./3d-filter-blender-driver.py -f %s >& /tmp/3d-filter-blender.log' % self.filename)

  def EmitImage(self):
    item = form['Image']
    filename = self.filename
    print "Filename: %s<br>" % filename
    print "<img src='/3d-filter/%sXX0001.jpg'>" % filename
    print "<img src='/3d-filter/%s'>" % filename


  def EmitHtml(self):
    print "Content-Type: text/html"
    print
    print """\
<html>
<title>3D For Free!</title>
<body>
"""
    self.RunBlender()
    self.EmitImage()
    print "<br><a href=/3d-filter>Go Back</a><br>"
    print """</body></html>"""

  def Run(self):
    self.EmitHtml()
    pass


if __name__ == '__main__':
  frak = BlenderWeb()
  frak.image = upload_image;
  frak.Run()
