#!/usr/bin/python2
"I am the supervisor"

import os
import time
import sys


pid = os.getpid()
xysize = 512

anti_alias_level = 1
batch = True
if len(sys.argv) > 1:
  argv = sys.argv
  i = 0
  while i < len(argv):
    a = argv[i]
    if a == '-f':
      filename = '/var/www/html/3d-filter/' + argv[i + 1]
      i += 1
    else:
      i += 1
else:
  pass


def run_command(cmd):
  #print('running %s' % cmd)
  os.system(cmd)

# template-3d-filter.py expect: /tmp/r-XXXXXXX.tga and /tmp/t-XXXXXXXX.tga
pyout = '/tmp/p-%d' % pid
cmd = "sed -e 's/XXXXXXXX/%d/' template-3d-filter.py > %s" % (pid, pyout)
run_command(cmd)

cmd = "chmod a+x %s" % pyout
run_command(cmd)


if True:
  start = time.time()
  # remove old texture and heightfield images
  ###cmd = '/bin/rm -f /tmp/t-%d.tga /tmp/r-%d.tga' % (pid, pid)
  run_command(cmd)
  cmd = 'echo %s >> /tmp/foofoo' % filename
  run_command(cmd)
  cmd = 'echo %d >> /tmp/foofoo' % pid
  run_command(cmd)
  cmd = 'anytopnm %s | pamtotga >  /tmp/t-%d.tga' % (filename, pid)
  run_command(cmd)
  cmd = 'anytopnm %s | ppmtopgm > /tmp/totally-tmp-%d.pgm' % (filename, pid)
  run_command(cmd)
  # create heightfield image 
  cmd = 'cat /tmp/totally-tmp-%d.pgm | pamscale -filter cubic -xysize %d %d' % (pid, xysize, xysize)
  #cmd += '|  pnmsmooth -width 3 -height 3'
  #cmd += '|  pnmsmooth -width 3 -height 3'
  cmd +=  '|  pamtotga > /tmp/r-%d.tga' % pid
  run_command(cmd)
  # create texture
  output_filename = filename + 'XX'
  if not os.path.isfile(output_filename):
    cmd = 'blender blank1.blend -o %s -P %s -b -f 1' % (
        output_filename, pyout)
  else:
    cmd = '/bin/true'
  run_command(cmd)
  #print 'Time to Execute: %3.2f seconds' % (start - time.time())
#Clean up
cmd = '/bin/rm -f /tmp/r-%d.tga /tmp/t-%d.tga /tmp/t-%d.pgm /tmp/totally-tmp-%d.pgm %s' % (
     pid, pid, pid, pid, pyout)
run_command(cmd)
